# -*- coding: utf-8 -*-
# @Author: StudentCWZ
# @Date:   2020-11-30 13:39:18
# @Last Modified by:   Gree
# @Last Modified time: 2020-12-18 15:37:08



import re
import pandas as pd


def ScienceCheck(input_df):
    """
    模块功能：检查science类的语料字段domain、intent、response_text是否正确
    iterrows: 返回值为元组,(index,row)
    """
    print('The module of science_check is running!')

    for index, row in input_df.iterrows():
        query = row['query']
        domain = row['domain']
        intent = row['intent']
        response_text = row['response_text']

        try:
            # 正则表达式匹配数据规律
            query_result = re.search(r'.*?(加|减|乘|除|等于|次方|光年|换算|长度).*', query)
            if query_result is not None and '站在' not in query:
                if domain == 'science':
                    row['domain_is_right'] = 'yes'
                    if 'calculator' in intent or 'unit_' in intent:
                        row['intent_is_right'] = 'yes'
                    else:
                        row['intent_is_right'] = 'no'

                    try:
                        if ('等于' in response_text or '单位' in response_text or '做不出来' in response_text) and '24乘以50384乘以59等于' not in query:
                            row['response_is_right'] = 'yes'
                        else:
                            row['response_is_right'] = 'no'
                    except:
                        pass


                    yield {
                        # 'initial_id': row['id'],
                        'date_time': row['date_time'],
                        'request_id': row['request_id'],
                        'mac_wifi': row['mac_wifi'],
                        'user_id': row['user_id'],
                        'query': query,
                        'domain': domain,
                        'intent': intent,
                        'response_text': response_text,
                        'domain_is_right': row['domain_is_right'],
                        'intent_is_right': row['intent_is_right'],
                        'response_is_right': row['response_is_right']
                    }

                else:
                    pass

            else:
                pass
        except:
            pass

    print('The module of science_check is executed!')
